<?php

/**
 *
 * @category Php
 * @package  /dbfix/
 * @created  22/05/2015
 * @author   João Garcia <joao.garcia@tecfood.com>
 * @license  www.tecfood.com - Tecfood Company
 */
 
// Inicia a conexão com os arquivos do banco.

require __DIR__ . "/baseEntity.php";
require __DIR__ . "/Entity.php";

/** @var \Doctrine2\ORM\EntityManager $entityManager */
$entityManager = require __DIR__ . "/bootstrap.php";

// Pega a conexão com o metadados do cliente.
$factory = $entityManager->getMetadataFactory();

// Declara as variáveis que serão utilizadas no script
$colunas = '';
$tabela = '';
$colunasInexistentes = array();
$existe = true;

// Dá uma mensagem de inicialização da execução do script
echo "Inicio";

$nomesDiretorio = scandir(__DIR__ . "/../dcm");
unset($nomesDiretorio[0]);
unset($nomesDiretorio[1]);
sort($nomesDiretorio);
$nomeClasseDoctrine = '';
$ponto = '"';

foreach ($nomesDiretorio as $nClasse) {
    try {
        $nomeExplode = explode('.', $nClasse);
        $nomeClasseQuery = strtoupper($nomeExplode[2]);
        $nomeClasseDoctrine = $nomeExplode[0] . '\\' . $nomeExplode[1] . '\\' . $nomeExplode[2];
        $metadataTodaTabela = $factory->getMetadataFor($nomeClasseDoctrine);

           $registroBC = $entityManager->getConnection()->fetchAll("
				SELECT COLUMN_NAME as Column_Name
				FROM USER_TAB_COLUMNS
				WHERE TABLE_NAME LIKE '$nomeClasseQuery'");

           if(empty($registroBC)) {
               array_push($colunasInexistentes, "A tabela ". $nomeClasseQuery . "  não existe. " . PHP_EOL);
               continue 1;
           } else {
               $columnsNoIndice = array();

               foreach ($registroBC as $row) {

                   $columnsNoIndice[$row["COLUMN_NAME"]] = true;
               }
           }

        foreach ($metadataTodaTabela->columnNames as $nomeColunaXML) {

            if (isset($columnsNoIndice[$nomeColunaXML])) {
                continue 1;
            } else {
                array_push($colunasInexistentes, "A coluna " . $nomeColunaXML . "  da tabela " . $nomeClasseQuery . "  não existe" . PHP_EOL);
            }

        }
    } 
    catch (\Exception $e) {
        array_push($colunasInexistentes, PHP_EOL . ' Tabela ' . $nomeClasseDoctrine . PHP_EOL. $e. PHP_EOL);
        file_put_contents(__DIR__ . "/dbfix_log.txt", $colunasInexistentes);
    }
}
file_put_contents(__DIR__ . "/dbfix_log.txt", $colunasInexistentes);

    echo PHP_EOL . "Arquivo Criado!! ";
