-- ================================================================== --
-- SISTEMA         : PONTO DE VENDA                                   --
-- DATA DA CRIAO : INCIO - 31/03/2004                              --
-- CRIAO         : Renata Diniz                                     --
-- OBJETIVOS       : Gerar vendas                                     --
-- @C:\WIN_V4\SQL\END_CONV\ORACLE\3842_PDVSTPO.SQL                    --
-- ================================================================== --

CREATE OR REPLACE
PROCEDURE GERA_VENDA_CATRACA
  (
    P_CDFILIAL     IN MOVCAIXA.CDFILIAL%TYPE,
    P_CDOPERADOR   IN TURCAIXA.CDOPERADOR%TYPE,
    P_CDEMPRESA    IN VENDA.CDEMPRESA%TYPE,
    P_DTINI        IN DATE,
    P_DTFIN        IN DATE,
    P_CDCLIENTE    IN MOVICLIE.CDCLIENTE%TYPE,
    P_CDCONSUMIDOR IN MOVICLIE.CDCONSUMIDOR%TYPE,
    P_OPERADOR     IN MOVICLIE.CDOPERECSALD%TYPE,
    P_ERRO OUT VARCHAR2 )
AS
  V_DATA         VARCHAR(15);
  V_HORA         VARCHAR(15);
  V_DATAOLD      VARCHAR(15);
  V_CAIXA        VARCHAR(4);
  V_CDCLIENTE    VARCHAR(21);
  V_CDCONSUMIDOR VARCHAR(21);
  V_CDCCUSCLIE   VARCHAR(10);
  V_CDTIPOCONS   VARCHAR(2);
  V_NMCONSUMIDOR VARCHAR(50);
  V_CDIDCONSUMID VARCHAR(21);
  V_INSERE       BOOLEAN;
  V_CDSERVFILI   VARCHAR(5);
  V_CDPRODUTO    VARCHAR(10);
  V_CDCAIXA      VARCHAR(3);
  V_CDLOJA       VARCHAR(10);
  V_COUNT        NUMBER;
  V_PRECO        NUMBER;
  V_PRECOCL      NUMBER;
  V_PRECOTOT     NUMBER;
  V_CDTABEPREC   VARCHAR(4);
  V_DTINIVGPREC DATE;
  V_NRSEQUITVEND  VARCHAR(3);
  V_CDFILTABPREC  VARCHAR(4);
  V_CDTABEPRECCLI VARCHAR(3);
  V_DTINIVGPRECCLI DATE;
  V_IDREGDUP VARCHAR(1);
  /* Marcao de registro duplicado */
  V_IDPERMARCDUP VARCHAR(1);
  /* Permite marcao duplicada da Filial */
  V_IDREGDUPCATR VARCHAR(1);
  /* Permite marcao duplicada do Tipo de consumidor */
  V_CDCFILTABPRE  VARCHAR(4);
  V_CDTPCLIFILIAL VARCHAR(3);
  V_DTINIVGPRECLIFIL DATE;
  V_DTABERTURA DATE;
  V_DTMOVCLI   DATE;
  V_CODVENDA     VARCHAR(20);
  V_CODMOVCXA    VARCHAR(20);
  V_CODMOVCLI    VARCHAR(20);
  V_CAIXAOLD     VARCHAR(3);
  V_COUNTABER    NUMBER;
  V_CDTIPORECE   VARCHAR(3);
  V_CONTROLE     VARCHAR(1);
  V_STTIPOCONS   VARCHAR(2);
  V_CDFILIALDIA  VARCHAR(5);
  V_CDTABEPREDIA VARCHAR(4);
  V_DTINIVIGDIA DATE;
  V_STDIA  VARCHAR(5);
  V_STDIAT VARCHAR(5);
  V_DTFERIFILI DATE;
  V_PRECODIA     NUMBER;
  V_PERCVAL      VARCHAR(5);
  V_DESCACRE     VARCHAR(5);
  V_TPCONSDIA    VARCHAR(2);
  V_IDVISUACUPOM VARCHAR(1);
  V_PRECOACE     NUMBER;
  V_PRECODESC    NUMBER;
  V_QTCOMMIT     NUMBER;
  V_IDATUIDVCAT  VARCHAR(1);
  V_IDBXVENDACAT VARCHAR(1);
  V_VRTOTVENDA NUMBER;
BEGIN
  SELECT IDATUIDVCAT
    INTO V_IDATUIDVCAT
    FROM PARAVEND
   WHERE CDFILIAL = P_CDFILIAL;
  IF V_IDATUIDVCAT = 'S' THEN
    V_IDBXVENDACAT := 'N';
  ELSE
    V_IDBXVENDACAT := 'S';
  END IF;
   SELECT COUNT(CDTIPORECE)
     INTO V_COUNT
     FROM TIPORECE
    WHERE IDTIPORECE = 'A';
  IF V_COUNT         = 0 THEN
    P_ERRO         := 'No h tipo de recebimento dbito consumidor cadastrado.';
  END IF;
  IF P_ERRO IS NULL THEN
     V_NRSEQUITVEND     := '001';
     FOR CUR_LOGCATRACA IN
        (SELECT CDFILIAL, NRSEQLOGCAT, CDCAIXLOGCAT, DSDTHRLOGCAT, NRIDENLOGCAT, IDSIMPLOGCAT,
                IDCRALOGCAT, IDCATLOGCAT, IDDATLOGCAT, IDSERLOGCAT, IDPROLOGCAT, IDDUPLOGCAT,
                IDCRAHABFILI, DTIMPLOGCAT, CDOPERADOR, DSOBSLOGCAT, NRSEQARQIMP, NMARQLOGCAT,
                IDREGDUPLICADO
           FROM LOGCATRACA
          WHERE (CDFILIAL = P_CDFILIAL)
            AND (TRUNC(DTIMPLOGCAT) BETWEEN TO_CHAR(TO_DATE(P_DTINI,'DD/MM/YYYY HH24:MI:SS')) AND TO_CHAR(TO_DATE(P_DTFIN,'DD/MM/YYYY HH24:MI:SS')))
            AND (IDSIMPLOGCAT = 'P')
            AND (IDCRALOGCAT  = '2')
            AND (IDCATLOGCAT  = '2')
            AND (IDDATLOGCAT  = '2')
            AND (IDSERLOGCAT  = '2')
            AND (IDPROLOGCAT  = '2')
            AND (IDDUPLOGCAT  = '2')
            AND (IDCRAHABFILI = '2')
          ORDER BY DTIMPLOGCAT) LOOP
          V_DATAOLD    := '0';
          V_DATA       := SUBSTR(CUR_LOGCATRACA.DSDTHRLOGCAT, 1, INSTR(CUR_LOGCATRACA.DSDTHRLOGCAT, ' '));
          V_HORA       := SUBSTR(CUR_LOGCATRACA.DSDTHRLOGCAT, INSTR(CUR_LOGCATRACA.DSDTHRLOGCAT, ' ') + 1, 8);
          V_CAIXA      := CUR_LOGCATRACA.CDCAIXLOGCAT;
          V_DTABERTURA := TO_DATE(SUBSTR(CUR_LOGCATRACA.DSDTHRLOGCAT,1,10)||'00:00:01', 'DD/MM/YYYY HH24:MI:SS');
          V_DTMOVCLI   := TO_DATE(CUR_LOGCATRACA.DSDTHRLOGCAT, 'DD/MM/YYYY HH24:MI:SS');
          V_INSERE     := FALSE;
          V_IDREGDUP   := CUR_LOGCATRACA.IDREGDUPLICADO;
          /* Traz os dados do consumidor, referente a filial de importao */
          BEGIN
             V_CONTROLE := '2';
             SELECT COUNT(*)
               INTO V_COUNT
               FROM CONSUMIFILIAL CL, CONSUMIDOR CO, FILIAL FI
              WHERE CL.CDFILIAL     = FI.CDFILIAL
                AND FI.CDFILIAL    = P_CDFILIAL
                AND CO.CDIDCONSUMID = CUR_LOGCATRACA.NRIDENLOGCAT
                AND CL.CDCLIENTE = CO.CDCLIENTE
                AND CO.IDSITCONSUMI = '1'
                AND CL.CDCONSUMIDOR = CO.CDCONSUMIDOR;
          END;
          IF V_COUNT = 1 THEN
             BEGIN
                SELECT MAX(CO.CDCLIENTE) , MAX(CO.CDCONSUMIDOR),
                       MAX(CO.CDTIPOCONS), MAX(CO.NMCONSUMIDOR),
                       MAX(CO.CDCCUSCLIE), MAX(CO.CDIDCONSUMID)
                  INTO V_CDCLIENTE  , V_CDCONSUMIDOR   ,
                       V_CDTIPOCONS , V_NMCONSUMIDOR   ,
                       V_CDCCUSCLIE , V_CDIDCONSUMID
                  FROM CONSUMIFILIAL CL, CONSUMIDOR CO, FILIAL FI
                 WHERE CL.CDFILIAL     = FI.CDFILIAL
                   AND FI.CDFILIAL     = P_CDFILIAL
                   AND CO.CDIDCONSUMID = CUR_LOGCATRACA.NRIDENLOGCAT
                   AND CL.CDCLIENTE    = CO.CDCLIENTE
                AND CO.IDSITCONSUMI = '1' 
                   AND CL.CDCONSUMIDOR = CO.CDCONSUMIDOR;
             EXCEPTION
                WHEN NO_DATA_FOUND THEN
                     V_CDCLIENTE    := NULL;
                     V_CDCONSUMIDOR := NULL;
                     V_CDTIPOCONS   := NULL;
                     V_NMCONSUMIDOR := NULL;
                     V_CDCCUSCLIE   := NULL;
                     V_CDIDCONSUMID := NULL;
             END;
          END IF;

          IF V_COUNT > 1 THEN
             P_ERRO := 'Consumidor do Crach '|| CUR_LOGCATRACA.NRIDENLOGCAT ||',est associado a mais de uma filial. Favor realizar a correo do cadastro.';
             EXIT;
          END IF;

          IF V_COUNT = 0 THEN
             BEGIN
                V_CONTROLE := '2';
                SELECT MAX(CO.CDCLIENTE), MAX(CO.CDCONSUMIDOR), MAX(CO.CDTIPOCONS), MAX(CO.NMCONSUMIDOR),
                       MAX(CO.CDCCUSCLIE), MAX(CO.CDIDCONSUMID) INTO V_CDCLIENTE, V_CDCONSUMIDOR, V_CDTIPOCONS,
                       V_NMCONSUMIDOR, V_CDCCUSCLIE, V_CDIDCONSUMID
                  FROM CONSUMIDOR CO, CLIENFILIAL CL
                 WHERE (CO.CDIDCONSUMID = CUR_LOGCATRACA.NRIDENLOGCAT)
                   AND (CO.IDSITCONSUMI     = '1' )
                   AND (CO.CDCLIENTE        = CL.CDCLIENTE )
                   AND (CL.CDFILIAL         = P_CDFILIAL );
             EXCEPTION
                WHEN NO_DATA_FOUND THEN
                   V_CDCLIENTE    := NULL;
                   V_CDCONSUMIDOR := NULL;
                   V_CDTIPOCONS   := NULL;
                   V_NMCONSUMIDOR := NULL;
                   V_CDCCUSCLIE   := NULL;
                   V_CDIDCONSUMID := NULL;
             END;

             /* Traz os dados do consumidor, caso o cliente deste consumidor no esteja para nenhuma filial*/
             IF V_CDCLIENTE IS NULL THEN
                SELECT COUNT(*)
                  INTO V_COUNT
                  FROM (SELECT CO.CDCLIENTE, CO.CDCONSUMIDOR, CO.CDTIPOCONS,
                               CO.NMCONSUMIDOR, CO.CDCCUSCLIE, CO.CDIDCONSUMID
                          FROM CONSUMIDOR CO
                         WHERE (CO.CDIDCONSUMID = CUR_LOGCATRACA.NRIDENLOGCAT)
                           AND (CO.IDSITCONSUMI = '1')
                           AND (CO.CDCLIENTE NOT IN (SELECT CL.CDCLIENTE
                                                       FROM CLIENFILIAL CL
                                                      WHERE CL.CDCLIENTE = CO.CDCLIENTE)));
               IF V_COUNT = 0 THEN
                 P_ERRO := 'Crach '|| CUR_LOGCATRACA.NRIDENLOGCAT ||', no est associado a filial de importao. Favor associar o cliente a filial de importao.';
                 EXIT;
               END IF;

               IF V_COUNT > 1 THEN
                 P_ERRO := 'Crach '|| CUR_LOGCATRACA.NRIDENLOGCAT ||', no est associado a filial de importao. Favor associar o cliente correto a filial de importao.' ;
                 EXIT;
               END IF;

             END IF;

             IF V_CDCLIENTE IS NOT NULL THEN
                SELECT COUNT(*)
                  INTO V_COUNT
                  FROM (SELECT CO.CDCLIENTE, CO.CDCONSUMIDOR, CO.CDTIPOCONS, CO.NMCONSUMIDOR,
                               CO.CDCCUSCLIE, CO.CDIDCONSUMID
                          FROM CONSUMIDOR CO
                         WHERE (CO.CDIDCONSUMID = CUR_LOGCATRACA.NRIDENLOGCAT)
                           AND (CO.IDSITCONSUMI = '1')
                           AND (CO.CDCLIENTE IN (SELECT CL.CDCLIENTE
                                                   FROM CLIENFILIAL CL
                                                  WHERE CL.CDCLIENTE = CO.CDCLIENTE
                                                    AND CDFILIAL = P_CDFILIAL)));
                IF V_COUNT > 1 THEN
                   P_ERRO := 'Crach '|| CUR_LOGCATRACA.NRIDENLOGCAT ||', est cadastrado para mais que um consumidor para filial de importao. Favor realizar correo cadastro.' ;
                   EXIT;
                END IF;
             END IF;
          END IF;

          IF V_IDREGDUP = 'S' THEN
            BEGIN
               SELECT IDPERMARCDUP
                 INTO V_IDPERMARCDUP
                 FROM PARAVEND
                WHERE CDFILIAL = P_CDFILIAL;
            EXCEPTION
            WHEN NO_DATA_FOUND THEN
              V_IDPERMARCDUP := NULL;
            END;

            IF V_IDPERMARCDUP = 'S' THEN
              BEGIN
                 SELECT IDREGDUPCATR
                   INTO V_IDREGDUPCATR
                   FROM TIPOCONS
                  WHERE CDTIPOCONS = V_CDTIPOCONS;
              EXCEPTION
              WHEN NO_DATA_FOUND THEN
                V_IDREGDUPCATR := NULL;
              END;
            END IF;
          END IF;

          /* Insere venda de registro no duplicado ou
          Insere venda de registro duplicado que permite marcao duplicada */
          IF ((V_IDREGDUP = 'N') OR (V_IDREGDUP = 'S') AND (V_IDPERMARCDUP = 'S') AND (V_IDREGDUPCATR = 'S')) THEN
            NOVO_CODIGO('PEDIDOVENDA'||P_CDFILIAL||V_CAIXA, V_CODVENDA);
            V_CODVENDA := SUBSTR(V_CODVENDA, 11, 10);
            NOVO_CODIGO('MOVCAIXA'||P_CDFILIAL||V_CAIXA||V_DTABERTURA, V_CODMOVCXA);
            V_CODMOVCXA := SUBSTR(V_CODMOVCXA, 11, 10);
            NOVO_CODIGO('MOVCLIE'||V_CDCLIENTE, V_CODMOVCLI, 2);
            V_CODMOVCLI   := SUBSTR(V_CODMOVCLI, 11, 10);
            IF (V_DATAOLD <> V_DATA) OR (V_INSERE) OR (V_CAIXAOLD <> V_CAIXA) THEN
              /* Gera o novo cdigo para a nova data */
              NOVO_CODIGO('PEDIDOVENDA'||P_CDFILIAL||V_CAIXA,V_CODVENDA);
              V_CODVENDA := SUBSTR(V_CODVENDA, 11, 10);
              /* NOVO_CODIGO('MOVCAIXA'||P_CDFILIAL||V_CAIXA||V_DTABERTURA, V_CODMOVCXA);
              V_CODMOVCXA := SUBSTR(V_CODMOVCXA, 11, 10); */
              NOVO_CODIGO('MOVCLIE'||V_CDCLIENTE, V_CODMOVCLI, 2);
              V_CODMOVCLI := SUBSTR(V_CODMOVCLI, 11, 10);
              V_DATAOLD   := V_DATA;
              V_CAIXAOLD  := V_CAIXA;
               SELECT COUNT(*)
                 INTO V_COUNTABER
                 FROM TURCAIXA
                WHERE CDFILIAL = P_CDFILIAL
                  AND CDCAIXA      = V_CAIXA
                  AND DTABERCAIX   = V_DTABERTURA;
              IF V_COUNTABER   = 0 THEN
                 IF TO_DATE(V_DTABERTURA,'DD/MM/YYYY') <= TO_DATE('31/12/1899','DD/MM/YYYY') THEN
                    P_ERRO := 'Data includa inferior ou igual a 31/12/1899 no  permitida';
                    EXIT;
                 END IF;

                 INSERT INTO TURCAIXA
                    (CDFILIAL, CDCAIXA, DTABERCAIX, CDOPERABER, DTMOVTURCAIX, CDOPERADOR,
                     DTFECHCAIX, CDOPERFECH)
                 VALUES
                    (P_CDFILIAL, V_CAIXA, V_DTABERTURA, P_CDOPERADOR, V_DATA, P_CDOPERADOR,
                     V_DATA, P_CDOPERADOR);
                V_INSERE := FALSE;
              END IF;
            END IF;

            /* Verifica se existe servio e produto definidos para o horrio da venda */
             SELECT MAX(SVT.CDSERVFILI)
               INTO V_CDSERVFILI
               FROM SERVTURCAIXA SVT
              WHERE (SVT.CDFILIAL    = P_CDFILIAL)
                AND (SVT.CDCAIXA         = V_CAIXA )
                AND ((((SVT.HRINISERTUR <= SUBSTR(V_HORA,1,2)||SUBSTR(V_HORA,4,2))  AND
                       (SVT.HRFINSERTUR >= SUBSTR(V_HORA,1,2)||SUBSTR(V_HORA,4,2))) AND
                       (SVT.HRINISERTUR   < SVT.HRFINSERTUR))
                    OR
                    (((SVT.HRINISERTUR <= SUBSTR(V_HORA,1,2)||SUBSTR(V_HORA,4,2)) OR
                     (SVT.HRFINSERTUR >= SUBSTR(V_HORA,1,2)||SUBSTR(V_HORA,4,2))) AND (SVT.HRINISERTUR > SVT.HRFINSERTUR)));
            IF V_CDSERVFILI IS NULL THEN
              P_ERRO := 'Horrio sem servio definido.';
              EXIT;
            ELSE
               SELECT MAX(PT.CDPRODUTO)
                 INTO V_CDPRODUTO
                 FROM PRODTURCAIXA PT
                WHERE (PT.CDFILIAL = P_CDFILIAL)
                  AND (PT.CDCAIXA      = V_CAIXA )
                  AND (PT.CDSERVFILI   = V_CDSERVFILI);
               IF V_CDPRODUTO      IS NULL THEN
                  P_ERRO           := 'Servio sem produto cadastrado.';
                  EXIT;
               END IF;
            END IF;
            BEGIN
               SELECT CDCAIXA, CDLOJA INTO V_CDCAIXA, V_CDLOJA
                 FROM CAIXA
                WHERE (CDFILIAL = P_CDFILIAL)
                  AND (CDCAIXA      = V_CAIXA)
                ORDER BY CDCAIXA;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                    V_CDCAIXA := NULL;
                    V_CDLOJA  := NULL;
            END;
      
            /* Verifica se o caixa  grill */
             SELECT COUNT(*)
               INTO V_COUNT
               FROM CAIXA
              WHERE (CDFILIAL = P_CDFILIAL)
                AND (CDCAIXA      = V_CAIXA)
                AND (IDTIPOCAIXA  = '2');

            /* Se for, deleta a ultima venda realizada para o consumidor */
            IF V_COUNT <> 0 THEN
               DELETE
                 FROM MOVICLIE
                WHERE CDFILIAL||CDCAIXA||NRSEQVENDA IN (SELECT CDFILIAL||CDCAIXA||MAX(NRSEQVENDA)
                                                          FROM VENDA
                                                         WHERE (DTENTRVENDA = V_DATA )
                                                           AND (CDCONSUMIDOR = V_CDCONSUMIDOR)
                                                         GROUP BY CDFILIAL, CDCAIXA);
               DELETE
                 FROM MOVCAIXA
                WHERE CDFILIAL||CDCAIXA||NRSEQVENDA IN (SELECT CDFILIAL||CDCAIXA||MAX(NRSEQVENDA)
                                                          FROM VENDA
                                                         WHERE (DTENTRVENDA = V_DATA)
                                                           AND (CDCONSUMIDOR = V_CDCONSUMIDOR)
                                                         GROUP BY CDFILIAL, CDCAIXA);
               DELETE
                 FROM ITEMVENDA
                WHERE CDFILIAL||CDCAIXA||NRSEQVENDA IN (SELECT CDFILIAL||CDCAIXA||MAX(NRSEQVENDA)
                                                          FROM VENDA
                                                         WHERE (DTENTRVENDA = V_DATA )
                                                           AND (CDCONSUMIDOR    = V_CDCONSUMIDOR)
                                                         GROUP BY CDFILIAL, CDCAIXA);
               DELETE
                 FROM VENDA
                WHERE CDFILIAL||CDCAIXA||NRSEQVENDA IN (SELECT CDFILIAL||CDCAIXA||MAX(NRSEQVENDA)
                                                          FROM VENDA
                                                         WHERE (DTENTRVENDA = V_DATA )
                                                           AND (CDCONSUMIDOR    = V_CDCONSUMIDOR)
                                                         GROUP BY CDFILIAL, CDCAIXA);
            END IF;

            /* Insere a venda */
            INSERT INTO VENDA
              (CDFILIAL,   CDCAIXA,     NRSEQVENDA,  CDCLIENTE,   CDEMPRESA,  CDCONSUMIDOR,
               DTVENDA,
               DTENTRVENDA, IDSITUVENDA, CDFILIALTUR, CDCAIXATUR, DTABERTUR,
               CDSERVFILI, CDOPERADOR,  CDLOJA,      IDTIPOVENDA, CDCCUSCLIE, IDORIGEMVENDA,
               NRSEQARQIMP)
            VALUES
              (P_CDFILIAL, V_CAIXA,     V_CODVENDA,  V_CDCLIENTE, P_CDEMPRESA, V_CDCONSUMIDOR,
               TO_DATE(CUR_LOGCATRACA.DSDTHRLOGCAT, 'DD/MM/YYYY HH24:MI:SS'),
               TO_DATE(V_DATA, 'DD/MM/YYYY'), 'O', P_CDFILIAL, V_CAIXA, V_DTABERTURA,
               V_CDSERVFILI, P_CDOPERADOR, V_CDLOJA, 'I', V_CDCCUSCLIE, 'VND_CAT',
               '1'||SUBSTR(CUR_LOGCATRACA.NRSEQARQIMP,2,10));

            /* Busca a tabela de preco vigente
               Busca a tabela de preo configurada na tabela CLIENFILIAL */
            BEGIN
               SELECT CDCFILTABPRE, CDTABEPREC INTO V_CDCFILTABPRE, V_CDTPCLIFILIAL
                 FROM CLIENFILIAL
                WHERE CDCLIENTE = V_CDCLIENTE
                  AND CDFILIAL      = P_CDFILIAL;
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_CDCFILTABPRE  := NULL;
                     V_CDTPCLIFILIAL := NULL;
            END;

            SELECT MAX(DTINIVGPREC)
              INTO V_DTINIVGPRECLIFIL
              FROM TABEVEND
             WHERE (CDFILIAL = V_CDCFILTABPRE)
               AND (CDTABEPREC   = V_CDTPCLIFILIAL)
               AND (TO_DATE(TO_CHAR(SYSDATE, 'DD/MM/YYYY'), 'DD/MM/YYYY') BETWEEN DTINIVGPREC AND DTFINVGPREC);

            /*Busca a tabela de preo configurada na tabela Loja ou Filial*/
            SELECT MAX(LO.CDTABEPREC)
              INTO V_CDTABEPREC
              FROM LOJA LO, CAIXA CA
             WHERE (CA.CDFILIAL = P_CDFILIAL)
               AND (CA.CDCAIXA = V_CDCAIXA )
               AND (CA.CDFILIAL = LO.CDFILIAL)
               AND (CA.CDLOJA = LO.CDLOJA );

            IF V_CDTABEPREC IS NULL THEN
               SELECT MAX(CDTABEPREC)
                 INTO V_CDTABEPREC
                 FROM PARAVEND
                WHERE CDFILIAL = P_CDFILIAL;
            END IF;

            SELECT MAX(DTINIVGPREC)
              INTO V_DTINIVGPREC
              FROM TABEVEND
             WHERE (CDFILIAL = P_CDFILIAL )
               AND (CDTABEPREC   = V_CDTABEPREC)
               AND (TO_DATE(TO_CHAR(SYSDATE, 'DD/MM/YYYY'), 'DD/MM/YYYY') BETWEEN DTINIVGPREC AND DTFINVGPREC);

            /*Busca a tabela de preo configurada na tabela CLIENTE*/
            BEGIN
               SELECT CDFILTABPREC, CDTABEPREC INTO V_CDFILTABPREC, V_CDTABEPRECCLI
                 FROM CLIENTE
                WHERE CDCLIENTE = V_CDCLIENTE;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                 V_CDFILTABPREC  := NULL;
                 V_CDTABEPRECCLI := NULL;
            END;

            SELECT MAX(DTINIVGPREC)
              INTO V_DTINIVGPRECCLI
              FROM TABEVEND
             WHERE (CDFILIAL = V_CDFILTABPREC )
               AND (CDTABEPREC   = V_CDTABEPRECCLI)
               AND (TO_DATE(TO_CHAR(SYSDATE, 'DD/MM/YYYY'), 'DD/MM/YYYY') BETWEEN DTINIVGPREC AND DTFINVGPREC);

            FOR CUR_PRODUTO IN
               (SELECT CDPRODUTO
                  FROM PRODTURCAIXA
                 WHERE (CDFILIAL = P_CDFILIAL)
                   AND (CDCAIXA      = V_CAIXA )
                   AND (CDSERVFILI   = V_CDSERVFILI)) LOOP
               /* Busca o preo do produto */
               /* Se no tiver, verifica se tem preco cliente por filial */
               SELECT NVL(MAX(VRPRECITEM),0), NVL(MAX(VRPRECITEMCL),0) INTO V_PRECO, V_PRECOCL
                 FROM ITEMPRECO
                WHERE (CDFILIAL = V_CDCFILTABPRE )
                  AND (CDTABEPREC   = V_CDTPCLIFILIAL )
                  AND (DTINIVGPREC  = V_DTINIVGPRECLIFIL )
                  AND (CDPRODUTO    = CUR_PRODUTO.CDPRODUTO )
                  AND (CDPRPAITABPR = CUR_PRODUTO.CDPRODUTO );

               V_CDFILIALDIA  := V_CDCFILTABPRE;
               V_CDTABEPREDIA := V_CDTPCLIFILIAL;
               V_DTINIVIGDIA  := V_DTINIVGPRECLIFIL;
               IF (V_PRECO     = 0) AND (V_PRECOCL = 0) THEN
                  /* Se no tiver, verifica se tem preco cliente */
                  SELECT NVL(MAX(VRPRECITEM),0), NVL(MAX(VRPRECITEMCL),0) INTO V_PRECO, V_PRECOCL
                   FROM ITEMPRECO
                  WHERE (CDFILIAL = V_CDFILTABPREC )
                    AND (CDTABEPREC   = V_CDTABEPRECCLI )
                    AND (DTINIVGPREC  = V_DTINIVGPRECCLI )
                    AND (CDPRODUTO    = CUR_PRODUTO.CDPRODUTO )
                    AND (CDPRPAITABPR = CUR_PRODUTO.CDPRODUTO );

                  V_CDFILIALDIA  := V_CDFILTABPREC;
                  V_CDTABEPREDIA := V_CDTABEPRECCLI;
                  V_DTINIVIGDIA  := V_DTINIVGPRECCLI;
                  IF (V_PRECO     = 0) AND (V_PRECOCL = 0) THEN
                     /* Se no tiver, verifica na tabela de preo padro */
                     SELECT NVL(MAX(VRPRECITEM),0), NVL(MAX(VRPRECITEMCL),0) INTO V_PRECO, V_PRECOCL
                       FROM ITEMPRECO
                      WHERE (CDFILIAL = P_CDFILIAL )
                        AND (CDTABEPREC   = V_CDTABEPREC )
                        AND (DTINIVGPREC  = V_DTINIVGPREC )
                        AND (CDPRODUTO    = CUR_PRODUTO.CDPRODUTO)
                        AND (CDPRPAITABPR = CUR_PRODUTO.CDPRODUTO);

                     V_CDFILIALDIA  := P_CDFILIAL;
                     V_CDTABEPREDIA := V_CDTABEPREC;
                     V_DTINIVIGDIA  := V_DTINIVGPREC;
                   END IF;
               END IF;

               /* ##Calcular Preos Diferenciados (descontos, acrescimos)## */
               /* Tipo de consumidor */
               V_STDIA := '';

               /* Verifica o dia do Preo diferenciado*/
               SELECT NVL(MAX(NRDIASEMANPR),0)
                 INTO V_STDIAT
                 FROM ITEMPRECODIA
                WHERE CDFILIAL = V_CDFILIALDIA
                  AND CDTABEPREC   = V_CDTABEPREDIA
                  AND DTINIVGPREC  = V_DTINIVIGDIA
                  AND CDPRODUTO    = CUR_PRODUTO.CDPRODUTO;

               BEGIN
                  SELECT MAX(CDTIPOCONS)
                    INTO V_STTIPOCONS
                    FROM CONSUMIDOR
                   WHERE (CDCLIENTE = V_CDCLIENTE )
                     AND (CDCONSUMIDOR  = V_CDCONSUMIDOR);
               EXCEPTION
                  WHEN NO_DATA_FOUND THEN
                     V_STTIPOCONS := 'T';
               END;

               /* Verificar o dia */
               /* Feriado */
               SELECT MAX(DTFERIFILI)
                 INTO V_DTFERIFILI
                 FROM FERIFILI
                WHERE (CDFILIAL = P_CDFILIAL)
                  AND (DTFERIFILI = TO_DATE(V_DATA));
               IF NOT (V_DTFERIFILI IS NULL) THEN
                  IF V_STDIAT         = 'F' THEN
                     V_STDIA          := 'F';
                  END IF;
                  V_DTFERIFILI := '';
               ELSE
                  /* Vespera de Feriado */
                  SELECT MAX(DTFERIFILI)
                    INTO V_DTFERIFILI
                    FROM FERIFILI
                   WHERE (CDFILIAL = P_CDFILIAL)
                     AND (DTFERIFILI   = TO_DATE(V_DATA)+1);
               END IF;
               IF NOT (V_DTFERIFILI IS NULL) THEN
                  IF V_STDIAT = 'V' THEN
                     V_STDIA := 'V';
                  END IF;
               END IF;

               IF (V_STDIA IS NULL) THEN
                 /* Dia da semana */
                  SELECT TO_CHAR(TO_DATE(V_DATA), 'DY')
                    INTO V_STDIA
                    FROM DUAL;
                  IF ((V_STDIA = 'DOM') OR (V_STDIA = 'SUN') ) THEN
                     V_STDIA   := '1';
                  END IF;
                  IF ((V_STDIA = 'SEG') OR (V_STDIA = 'MON')) THEN
                     V_STDIA   := '2';
                  END IF;
                  IF ((V_STDIA = 'TER') OR (V_STDIA = 'TUE')) THEN
                     V_STDIA   := '3';
                  END IF;
                  IF ((V_STDIA = 'QUA') OR (V_STDIA = 'WED')) THEN
                     V_STDIA   := '4';
                  END IF;
                  IF ((V_STDIA = 'QUI') OR (V_STDIA = 'THU')) THEN
                     V_STDIA   := '5';
                  END IF;
                  IF ((V_STDIA = 'SEX') OR (V_STDIA = 'FRI')) THEN
                     V_STDIA   := '6';
                  END IF;
                  IF ((V_STDIA = 'SB') OR (V_STDIA = 'SAT')) THEN
                     V_STDIA   := '7';
                  END IF;
               END IF;
               IF V_STDIAT = 'T' THEN
                  V_STDIA  := V_STDIAT;
               END IF;

               /* Verifica desconto, acrescimo e tipo de consumidor*/
               SELECT NVL(MAX(VRPRECODIA),0), NVL(MAX(IDPERVALORPR), 0), NVL(MAX(IDDESCACREPR),0), NVL(MAX(CDTIPOCONSPD),0),
                      NVL(MAX(IDVISUACUPOM),0) INTO V_PRECODIA, V_PERCVAL, V_DESCACRE, V_TPCONSDIA, V_IDVISUACUPOM
                 FROM ITEMPRECODIA
                WHERE CDFILIAL = V_CDFILIALDIA
                  AND CDTABEPREC   = V_CDTABEPREDIA
                  AND DTINIVGPREC  = V_DTINIVIGDIA
                  AND CDPRODUTO    = CUR_PRODUTO.CDPRODUTO
                  AND CDPRPAITABPR = CUR_PRODUTO.CDPRODUTO
                  AND NRDIASEMANPR = V_STDIA
                  AND SUBSTR(V_HORA,1,2)||SUBSTR(V_HORA,4,2) BETWEEN HRINIPRECDIA AND HRFINPRECDIA
                  AND TO_DATE(V_DATA) BETWEEN DTINIVALPREC AND DTFINVALPREC;

               /* Verifica Tipo de Consumidor */
               IF NOT(V_TPCONSDIA = 'T') THEN
                  IF V_TPCONSDIA  <> V_STTIPOCONS THEN
                     V_PRECODIA    := '0';
                  END IF;
               END IF;

               /* Calcula Preo */
               IF (V_PRECODIA <> 0) THEN
                  IF V_PERCVAL = 'V' THEN
                     IF V_DESCACRE  = 'A' THEN
                        V_PRECOACE  := V_PRECODIA;
                        V_PRECODESC := '0';
                     ELSE
                        V_PRECODESC := V_PRECODIA;
                        V_PRECOACE  := '0';
                     END IF;
                  ELSE
                     IF V_DESCACRE  = 'A' THEN
                        V_PRECOACE  := ((V_PRECODIA / 100) * (V_PRECO));
                        V_PRECODESC := '0';
                     ELSE
                        V_PRECODESC := ((V_PRECODIA / 100) * (V_PRECO));
                        V_PRECOACE  := '0';
                     END IF;
                  END IF;
               END IF;
               IF V_PRECODIA  = 0 THEN
                  V_PRECOACE  := '0';
                  V_PRECODESC := '0';
               END IF;

               /* Se o preo do produto no for 0, insere o item */
               IF ((V_PRECO <> 0) OR (V_PRECOCL <> 0)) AND (V_CONTROLE = 2) THEN
                  IF V_IDVISUACUPOM = 'S' THEN
                     INSERT INTO ITEMVENDA
                        (CDFILIAL, CDCAIXA, NRSEQVENDA, NRSEQUITVEND, QTPRODVEND, VRUNITVEND, VRUNITVENDCL,
                         VRACRITVEND, VRDESITVEND, CDPRODUTO)
                     VALUES
                        (P_CDFILIAL, V_CAIXA, V_CODVENDA, V_NRSEQUITVEND, 1, V_PRECO, V_PRECOCL,
                         V_PRECOACE, V_PRECODESC, CUR_PRODUTO.CDPRODUTO);
                  ELSE
                     INSERT INTO ITEMVENDA
                        (CDFILIAL, CDCAIXA, NRSEQVENDA, NRSEQUITVEND, QTPRODVEND,
                         VRUNITVEND,
                         VRUNITVENDCL, VRACRITVEND, VRDESITVEND, CDPRODUTO)
                     VALUES
                        (P_CDFILIAL, V_CAIXA, V_CODVENDA, V_NRSEQUITVEND, 1,
                         V_PRECO + V_PRECOACE - V_PRECODESC,
                         V_PRECOCL, 0, 0, CUR_PRODUTO.CDPRODUTO);
                  END IF;
                  V_NRSEQUITVEND := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQUITVEND) + 1)),3,'0');
                  SELECT MAX(CDTIPORECE) AS CDTIPORECE
                    INTO V_CDTIPORECE
                    FROM TIPORECE
                   WHERE IDTIPORECE = 'A';
          
                  V_PRECOTOT := (V_PRECO + V_PRECOCL + V_PRECOACE - V_PRECODESC);
                  NOVO_CODIGO('MOVCAIXA'||P_CDFILIAL||V_CAIXA||TO_CHAR(V_DTABERTURA, 'DD/MM/YYYY HH24:MI:SS'), V_CODMOVCXA);
                  V_CODMOVCXA := SUBSTR(V_CODMOVCXA, 11, 10);
                  INSERT INTO MOVCAIXA
                     (CDFILIAL, CDCAIXA, DTABERCAIX, NRSEQUMOVI, IDTIPOMOVIVE, VRMOVIVEND, NRSEQVENDA,
                      CDTIPORECE, DTHRINCMOV, DTMOVIMCAIXA, CDCLIENTE)
                  VALUES
                     (P_CDFILIAL, V_CAIXA, V_DTABERTURA, V_CODMOVCXA, 'E', V_PRECOTOT, V_CODVENDA,
                      V_CDTIPORECE, SYSDATE, TO_DATE(V_DATA, 'DD/MM/YYYY'), V_CDCLIENTE);
          
                  NOVO_CODIGO('MOVCLIE'||V_CDCLIENTE, V_CODMOVCLI, 2);
                  V_CODMOVCLI := SUBSTR(V_CODMOVCLI, 11, 10);

                  INSERT INTO MOVICLIE
                     (CDCLIENTE, NRSEQMOVCLI, CDCONSUMIDOR, VRMOVCLI, DTMOVCLI,
                      DSHISTMOV, IDTIPMOCVLI, CDFILIAL, CDCAIXA, NRSEQVENDA, DTABERCAIX,
                      NRSEQUMOVI, CDTIPORECE, VRSALDOCONS, VRMOVPESCONS, VRSALDPECONS,
                      CDOPERADOR, DTATUMOVCLIE, DSATUMOVCLIE, DTMOVIMCLIE, CDOPERECSALD,
                      DTRECMOVCLIE, IDBXVENDACAT, DTULTATUMCLI)
                  VALUES
                     (V_CDCLIENTE, V_CODMOVCLI, V_CDCONSUMIDOR, V_PRECOTOT, V_DTMOVCLI,
                      NULL, 'D', P_CDFILIAL, V_CAIXA, V_CODVENDA, V_DTABERTURA,
                      V_CODMOVCXA, V_CDTIPORECE, NULL, NULL, NULL,
                      P_CDOPERADOR, NULL, NULL, TO_DATE(V_DATA, 'DD/MM/YYYY'), NULL,
                      NULL, V_IDBXVENDACAT, SYSDATE);
                  IF V_PRECOCL > 0 THEN
                     NOVO_CODIGO('MOVCLIE'||V_CDCLIENTE, V_CODMOVCLI, 2);
                     V_CODMOVCLI := SUBSTR(V_CODMOVCLI, 11, 10);
                     INSERT INTO MOVICLIE
                        (CDCLIENTE, NRSEQMOVCLI, CDCONSUMIDOR, VRMOVCLI, DTMOVCLI,
                         DSHISTMOV, IDTIPMOCVLI, CDFILIAL, CDCAIXA, NRSEQVENDA, DTABERCAIX,
                         NRSEQUMOVI, CDTIPORECE, VRSALDOCONS, VRMOVPESCONS, VRSALDPECONS,
                         CDOPERADOR, DTATUMOVCLIE, DSATUMOVCLIE, DTMOVIMCLIE, CDOPERECSALD,
                         DTRECMOVCLIE, IDBXVENDACAT, DTULTATUMCLI)
                     VALUES
                        (V_CDCLIENTE, V_CODMOVCLI, NULL, V_PRECOCL, V_DTMOVCLI,
                         NULL, 'D', P_CDFILIAL, V_CAIXA, V_CODVENDA, V_DTABERTURA,
                         V_CODMOVCXA, V_CDTIPORECE, NULL, NULL, NULL,
                         P_CDOPERADOR, NULL, NULL, TO_DATE(V_DATA, 'DD/MM/YYYY'), NULL,
                         NULL, V_IDBXVENDACAT, SYSDATE);
                  END IF;
               ELSE
                  /* No insere o produto que no tem preo */
                  UPDATE LOGCATRACA
                     SET DSOBSLOGCAT = DSOBSLOGCAT||'  Produto no importado devido  falta de preo. '
                   WHERE (CDFILIAL = P_CDFILIAL )
                     AND (NRSEQLOGCAT  = CUR_LOGCATRACA.NRSEQLOGCAT);

                  DELETE
                    FROM ITEMVENDA
                   WHERE CDFILIAL = P_CDFILIAL
                     AND CDCAIXA = V_CAIXA
                     AND NRSEQVENDA = V_CODVENDA;

                  DELETE
                    FROM MOVICLIE
                   WHERE CDFILIAL = P_CDFILIAL
                     AND CDCAIXA      = V_CAIXA
                     AND NRSEQVENDA   = V_CODVENDA;

                  DELETE
                    FROM MOVCAIXA
                   WHERE CDFILIAL = P_CDFILIAL
                     AND CDCAIXA      = V_CAIXA
                     AND NRSEQVENDA   = V_CODVENDA;
                  DELETE
                    FROM VENDA
                   WHERE CDFILIAL = P_CDFILIAL
                     AND CDCAIXA      = V_CAIXA
                     AND NRSEQVENDA   = V_CODVENDA;

                  V_INSERE   := TRUE;
                  V_CONTROLE := '1';
               END IF;
            END LOOP;


            /* SOMA O VALOR TOTAL DA VENDA PARA ATUALIZAR A TABELA VENDA POSTERIORMENTE */
            V_VRTOTVENDA := 0;
            BEGIN
               SELECT SUM(TRUNC(QTPRODVEND * (VRUNITVEND + NVL(VRUNITVENDCL, 0)), 2) - NVL(VRDESITVEND, 0) + NVL(VRACRITVEND, 0))
                 INTO V_VRTOTVENDA
                 FROM ITEMVENDA
                WHERE CDFILIAL = P_CDFILIAL
                  AND CDCAIXA = V_CAIXA
                  AND NRSEQVENDA = V_CODVENDA;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_VRTOTVENDA := 0;
            END;

            /* ATUALIZA A VENDA COM SEU VALOR TOTAL */
            UPDATE VENDA
               SET VRTOTVENDA = V_VRTOTVENDA
             WHERE CDFILIAL = P_CDFILIAL
               AND CDCAIXA = V_CAIXA
               AND NRSEQVENDA = V_CODVENDA;

            /* Atualiza o saldo do consumidor*/
            /* Segundo o Sr. Ailton no  necessrio atualizar o saldo do consumidor na importao
            das venda da catraca. Dessa forma, haver uma melhora na performance da mesma.*/
            /* ATUALIZA_SALDO_CONS(P_CDFILIAL, V_CDCLIENTE, V_CDCONSUMIDOR, V_DTABERTURA, P_CDOPERADOR);*/
            /* Atualiza a logcatracapk indicando que uma venda foi importada*/
          END IF;

          UPDATE LOGCATRACAPK
             SET NRSEQARQIMPK = '1'||SUBSTR(NRSEQARQIMPK,2,10)
           WHERE NRSEQARQIMPK = CUR_LOGCATRACA.NRSEQARQIMP;

          IF ((V_PRECO        <> 0) OR (V_PRECOCL <> 0)) AND (V_CONTROLE = 2) THEN
             DELETE
               FROM LOGCATRACA
              WHERE (CDFILIAL = P_CDFILIAL )
                AND (NRSEQLOGCAT  = CUR_LOGCATRACA.NRSEQLOGCAT);
          END IF;

          IF V_QTCOMMIT = 500 THEN
             COMMIT;
             V_QTCOMMIT := 0;
          END IF;
          V_QTCOMMIT := v_QTCOMMIT + 1;
     END LOOP;
  END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERA_VENDA_CATRACA','6.10.xxx'); END;
/