/* Tabela BASECALCTPOPER: Imposto */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela BASECALCTPOPER */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela BASECALCTPOPER,
             utilizando a tabela Geral de Logs de Operaes */


IF EXISTS(SELECT * FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'LOG_FIS_BASECALCTPOP' AND
                TYPE   = 'TR'                  AND
                U.UID  = O.UID                 AND
                U.NAME = USER)
DROP TRIGGER LOG_FIS_BASECALCTPOP
GO


CREATE TRIGGER LOG_FIS_BASECALCTPOP
ON BASECALCTPOPER
FOR INSERT, UPDATE, DELETE
AS
   DECLARE @V_USUARIO   VARCHAR(40);
   DECLARE @V_TIPO      VARCHAR(1);
   DECLARE @V_ITPESQ    VARCHAR(40);
   DECLARE @V_DESC      VARCHAR(300);
   DECLARE @V_DTOPER    DATETIME;

/*VARIVEIS DO CURSOR C_CURSORal*/

   DECLARE @V_ID_COMANDO           VARCHAR(1);

   DECLARE @V_CDIMPOSTO_OLD      VARCHAR(2);	
   DECLARE @V_NRSEQBCALTPOP_OLD  VARCHAR(2);
   DECLARE @V_IDENTRSAIDOP_OLD   VARCHAR(1);
   DECLARE @V_CDTIPOOPER_OLD     VARCHAR(2);
   DECLARE @V_CDIMPOBCALC_OLD    VARCHAR(2);
   DECLARE @V_CDCFOPIMPOTPOP_OLD VARCHAR(11);
   DECLARE @V_CDCSTIMPOTPOP_OLD  VARCHAR(2);
   DECLARE @V_CDFISCIMPOTPOP_OLD VARCHAR(1);		

   DECLARE @V_CDIMPOSTO_NEW      VARCHAR(2);	
   DECLARE @V_NRSEQBCALTPOP_NEW  VARCHAR(2);
   DECLARE @V_IDENTRSAIDOP_NEW   VARCHAR(1);
   DECLARE @V_CDTIPOOPER_NEW     VARCHAR(2);
   DECLARE @V_CDIMPOBCALC_NEW    VARCHAR(2);
   DECLARE @V_CDCFOPIMPOTPOP_NEW VARCHAR(11);
   DECLARE @V_CDCSTIMPOTPOP_NEW  VARCHAR(2);
   DECLARE @V_CDFISCIMPOTPOP_NEW VARCHAR(1);	
BEGIN
   SET @V_TIPO = '0';
   SET @V_DESC = '';
   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO,' ' );

   DECLARE C_CURSOR CURSOR FOR
      SELECT
         'D' IDCOMANDO,
         CDIMPOSTO,
         NRSEQBCALTPOP,
         IDENTRSAIDOP,
         CDTIPOOPER,
         CDIMPOBCALC,
	 CDCFOPIMPOTPOP,
	 CDCSTIMPOTPOP,
	 CDFISCIMPOTPOP,
 	 NULL,
	 NULL,
	 NULL,
	 NULL,
	 NULL,
	 NULL,
	 NULL,
	 NULL
      FROM
         DELETED
      WHERE
         CDIMPOSTO NOT IN (SELECT CDIMPOSTO FROM INSERTED)
      UNION ALL

      SELECT
         'U' IDCOMANDO,
	 DELETED.CDIMPOSTO,
         DELETED.NRSEQBCALTPOP,
         DELETED.IDENTRSAIDOP,
         DELETED.CDTIPOOPER,
         DELETED.CDIMPOBCALC,
         DELETED.CDCFOPIMPOTPOP,
         DELETED.CDCSTIMPOTPOP,
         DELETED.CDCSTIMPOTPOP,

	 INSERTED.CDIMPOSTO,
         INSERTED.NRSEQBCALTPOP,
         INSERTED.IDENTRSAIDOP,
         INSERTED.CDTIPOOPER,
         INSERTED.CDIMPOBCALC,
         INSERTED.CDCFOPIMPOTPOP,
         INSERTED.CDCSTIMPOTPOP,
         INSERTED.CDCSTIMPOTPOP
      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDIMPOSTO = DELETED.CDIMPOSTO
      UNION ALL

      SELECT
         'I' IDCOMANDO,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
	 NULL,
 	 NULL,
	 INSERTED.CDIMPOSTO,
         INSERTED.NRSEQBCALTPOP,
         INSERTED.IDENTRSAIDOP,
         INSERTED.CDTIPOOPER,
         INSERTED.CDIMPOBCALC,
         INSERTED.CDCFOPIMPOTPOP,
         INSERTED.CDCSTIMPOTPOP,
         INSERTED.CDCSTIMPOTPOP
      FROM
         INSERTED
      WHERE
         CDIMPOSTO NOT IN (SELECT CDIMPOSTO FROM DELETED);


   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
   				 @V_CDIMPOSTO_OLD,
   	 			 @V_NRSEQBCALTPOP_OLD,
   				 @V_IDENTRSAIDOP_OLD,
  				 @V_CDTIPOOPER_OLD,
  				 @V_CDIMPOBCALC_OLD,
   				 @V_CDCFOPIMPOTPOP_OLD,
   				 @V_CDCSTIMPOTPOP_OLD,
   				 @V_CDFISCIMPOTPOP_OLD,
				 
                                 @V_CDIMPOSTO_NEW,
   	 			 @V_NRSEQBCALTPOP_NEW,
   				 @V_IDENTRSAIDOP_NEW,
  				 @V_CDTIPOOPER_NEW,
  				 @V_CDIMPOBCALC_NEW,
   				 @V_CDCFOPIMPOTPOP_NEW,
   				 @V_CDCSTIMPOTPOP_NEW,
   				 @V_CDFISCIMPOTPOP_NEW;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF @V_ID_COMANDO = 'D' BEGIN
         IF @V_CDIMPOSTO_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'CodImpost=' + @V_CDIMPOSTO_OLD;
         END;
         IF @V_NRSEQBCALTPOP_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NumSeqBaseCalc=' + @V_NRSEQBCALTPOP_OLD;
         END;
         IF @V_IDENTRSAIDOP_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' EntraSaid=' + @V_IDENTRSAIDOP_OLD;
         END;

         IF @V_CDTIPOOPER_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' TipoOper=' + @V_CDTIPOOPER_OLD;
         END;

         IF @V_CDIMPOBCALC_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' ImpoBCalc=' + @V_CDIMPOBCALC_OLD;
         END;
         IF @V_CDCFOPIMPOTPOP_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CFOPImpostOp=' + @V_CDCFOPIMPOTPOP_OLD;
         END;

	 IF @V_CDFISCIMPOTPOP_OLD IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CodFiscImp=' + @V_CDFISCIMPOTPOP_OLD;
         END;

	 IF @V_CDCSTIMPOTPOP_OLD IS NOT NULL BEGIN
	    SET @V_DESC = @V_DESC + ' CSTImpostOp=' + @V_CDCSTIMPOTPOP_OLD;
	 END;


         SET @V_TIPO = '3';
         SET @V_ITPESQ = @V_CDIMPOSTO_OLD;
      END
      ELSE IF @V_ID_COMANDO = 'U' BEGIN
         IF (@V_CDIMPOSTO_NEW          <> @V_CDIMPOSTO_OLD)     OR
            (@V_NRSEQBCALTPOP_NEW      <> @V_NRSEQBCALTPOP_OLD) OR
            (@V_IDENTRSAIDOP_NEW       <> @V_IDENTRSAIDOP_OLD)  OR
            (@V_CDTIPOOPER_NEW         <> @V_CDTIPOOPER_OLD)    OR
            (@V_CDIMPOBCALC_NEW        <> @V_CDIMPOBCALC_OLD)   OR
            (@V_CDCFOPIMPOTPOP_NEW     <> @V_CDCFOPIMPOTPOP_OLD)OR
	    (@V_CDCSTIMPOTPOP_NEW      <> @V_CDCSTIMPOTPOP_OLD) OR
            (@V_CDFISCIMPOTPOP_NEW     <> @V_CDFISCIMPOTPOP_OLD)BEGIN

            SET @V_TIPO   = '2';
            SET @V_ITPESQ = @V_CDIMPOSTO_OLD;
         END;
      END
      ELSE BEGIN
         SET @V_TIPO = '1';
         SET @V_ITPESQ = @V_CDIMPOSTO_NEW;
      END;

      IF @V_CDIMPOSTO_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + 'CodImpost=' + @V_CDIMPOSTO_NEW;
         END;
         IF @V_NRSEQBCALTPOP_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' NumSeqBaseCalc=' + @V_NRSEQBCALTPOP_NEW;
         END;
         IF @V_IDENTRSAIDOP_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' EntraSaid=' + @V_IDENTRSAIDOP_NEW;
         END;

         IF @V_CDTIPOOPER_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' TipoOper=' + @V_CDTIPOOPER_NEW;
         END;

         IF @V_CDIMPOBCALC_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' ImpoBCalc=' + @V_CDIMPOBCALC_NEW;
         END;
         IF @V_CDCFOPIMPOTPOP_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CFOPImpostOp=' + @V_CDCFOPIMPOTPOP_NEW;
         END;

	 IF @V_CDFISCIMPOTPOP_NEW IS NOT NULL BEGIN
            SET @V_DESC = @V_DESC + ' CodFiscImp=' + @V_CDFISCIMPOTPOP_NEW;
         END;
	
	 IF @V_CDCSTIMPOTPOP_NEW IS NOT NULL BEGIN
	    SET @V_DESC = @V_DESC + 'CSTImpostOp='  + @V_CDCSTIMPOTPOP_NEW;
	 END;

      IF @V_TIPO <> '0' BEGIN
         EXEC NMUSUARIO @V_USUARIO;
         IF NOT @V_DESC IS NULL BEGIN
            IF NOT @V_USUARIO IS NULL BEGIN
               SET @V_DTOPER = GETDATE();

               INSERT INTO LOGOPERA
                  (NMTABELA,   DTOPERACAO, NMRESPOPER,
                   IDTIPOOPER, CDPESQITEM, DSOPERACAO)
               VALUES
                  ('BASECALCTPOPER',  @V_DTOPER, @V_USUARIO,
                   @V_TIPO, @V_ITPESQ, @V_DESC);
            END;
         END;
      END;
      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,
  				    @V_CDIMPOSTO_OLD,
   	 			    @V_NRSEQBCALTPOP_OLD,
   				    @V_IDENTRSAIDOP_OLD,
  			            @V_CDTIPOOPER_OLD,
  				    @V_CDIMPOBCALC_OLD,
   				    @V_CDCFOPIMPOTPOP_OLD,
   				    @V_CDCSTIMPOTPOP_OLD,
   			    	    @V_CDFISCIMPOTPOP_OLD,

                                    @V_CDIMPOSTO_NEW,
   	 			    @V_NRSEQBCALTPOP_NEW,
   				    @V_IDENTRSAIDOP_NEW,
  				    @V_CDTIPOOPER_NEW,
  				    @V_CDIMPOBCALC_NEW,
   				    @V_CDCFOPIMPOTPOP_NEW,
   				    @V_CDCSTIMPOTPOP_NEW,
   				    @V_CDFISCIMPOTPOP_NEW;
   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO




-- VERSAO --
EXEC ATUVEROBJ 'LOG_FIS_BASECALC','5.25.000';
GO







