/*
Nome: 9803_CDPTRGS_LOG_CDP_INSUMETAPA.SQL
Criao:
   17/02/2009 - Henrique Guidi Lobato

   Descrio: A trigger insere registros na tabela LOGOPERA a partir das alteraes na tabela
              INSUMETAPA, para verifio de erros
*/
IF EXISTS(SELECT *
          FROM SYSOBJECTS O, SYSUSERS U
          WHERE O.NAME = 'LOG_CDP_INSUMETAPA' AND
                TYPE   = 'TR'                 AND
                U.UID  = O.UID                AND
                U.NAME = USER)

DROP TRIGGER LOG_CDP_INSUMETAPA
GO


CREATE TRIGGER LOG_CDP_INSUMETAPA
ON INSUMETAPA
FOR UPDATE,INSERT, DELETE
AS
BEGIN

   DECLARE @V_DSREMOTEADDR VARCHAR(15);
   DECLARE @V_DSREMOTEHOST VARCHAR(15);
   DECLARE @V_DSSERVERRDM  VARCHAR(20);
   DECLARE @V_DSSERVMETHOD VARCHAR(30);
   DECLARE @V_DSREMOTEOPER VARCHAR(12);
   DECLARE @V_DESC         VARCHAR(2000);
   DECLARE @V_ITPESQ       VARCHAR(80);
   DECLARE @V_NMOPERADOR   VARCHAR(40);
   DECLARE @V_IDCLIEATIV   VARCHAR(1);
   DECLARE @V_NRINCREST    VARCHAR(40);
   DECLARE @V_IDTIPOOPER   VARCHAR(1);

/*VARIVEIS DO CURSOR C_CURSOR*/
   DECLARE @V_ID_TRIGGER       VARCHAR(1);

   DECLARE @V_CDFILIAL_OLD      VARCHAR(4);
   DECLARE @V_CDPRODUTO_OLD     VARCHAR(10);
   DECLARE @V_CDPROCFABRIC_OLD  VARCHAR(10);
   DECLARE @V_CDETAPAPROD_OLD   VARCHAR(10);
   DECLARE @V_CDPRODINSUMO_OLD  VARCHAR(10);
   DECLARE @V_CDTIPOINSU_OLD    VARCHAR(3);
   DECLARE @V_IDUTAPRREQET_OLD  VARCHAR(1);
   DECLARE @V_QTINSUMETAPA_OLD  double precision;
   DECLARE @V_QTRENDINSU_OLD    double precision;
   DECLARE @V_IDSEMIACETAP_OLD  VARCHAR(1);
   DECLARE @V_IDLOTEPRETAP_OLD  VARCHAR(1);
   DECLARE @V_QTBRUTINSETP_OLD  double precision;
   DECLARE @V_VRPRENINSETP_OLD  double precision;
   DECLARE @V_IDTIPOPROPOR_OLD  VARCHAR(1);
   DECLARE @V_IDTIPOARREDO_OLD  VARCHAR(1);
   DECLARE @V_IDSUBOPINSU_OLD   CHAR(1);

   DECLARE @V_CDFILIAL_NEW      VARCHAR(4);
   DECLARE @V_CDPRODUTO_NEW     VARCHAR(10);
   DECLARE @V_CDPROCFABRIC_NEW  VARCHAR(10);
   DECLARE @V_CDETAPAPROD_NEW   VARCHAR(10);
   DECLARE @V_CDPRODINSUMO_NEW  VARCHAR(10);
   DECLARE @V_CDTIPOINSU_NEW    VARCHAR(3);
   DECLARE @V_IDUTAPRREQET_NEW  VARCHAR(1);
   DECLARE @V_QTINSUMETAPA_NEW  double precision;
   DECLARE @V_QTRENDINSU_NEW    double precision;
   DECLARE @V_IDSEMIACETAP_NEW  VARCHAR(1);
   DECLARE @V_IDLOTEPRETAP_NEW  VARCHAR(1);
   DECLARE @V_QTBRUTINSETP_NEW  double precision;
   DECLARE @V_VRPRENINSETP_NEW  double precision;
   DECLARE @V_IDTIPOPROPOR_NEW  VARCHAR(1);
   DECLARE @V_IDTIPOARREDO_NEW  VARCHAR(1);
   DECLARE @V_IDSUBOPINSU_NEW   CHAR(1);

/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   SET @V_DESC         = '';
   SET @V_ITPESQ       = '';
   SET @V_NMOPERADOR   = '';
   SET @V_IDCLIEATIV   = '';
   SET @V_NRINCREST    = '';
   SET @V_IDTIPOOPER   = '';

   EXEC NMUSUARIO  @V_NMOPERADOR;
   EXEC WEBTUNNING @V_DSREMOTEADDR,
                   @V_DSREMOTEHOST,
                   @V_DSSERVERRDM,
                   @V_DSSERVMETHOD,
                   @V_DSREMOTEOPER;

   DECLARE C_CURSOR CURSOR FOR
      SELECT
         'D' IDCOMANDO,
         CDFILIAL,
         CDPRODUTO,
         CDPROCFABRIC,
         CDETAPAPROD,
         CDPRODINSUMO,
         CDTIPOINSU,
         IDUTAPRREQET,
         QTINSUMETAPA,
         QTRENDINSU,
         IDSEMIACETAP,
         IDLOTEPRETAP,
         QTBRUTINSETP,
         VRPRENINSETP,
         IDTIPOPROPOR,
         IDTIPOARREDO,
         IDSUBOPINSU,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL

      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)
      UNION ALL

      SELECT
         'U' IDCOMANDO,

         DELETED.CDFILIAL,
         DELETED.CDPRODUTO,
         DELETED.CDPROCFABRIC,
         DELETED.CDETAPAPROD,
         DELETED.CDPRODINSUMO,
         DELETED.CDTIPOINSU,
         DELETED.IDUTAPRREQET,
         DELETED.QTINSUMETAPA,
         DELETED.QTRENDINSU,
         DELETED.IDSEMIACETAP,
         DELETED.IDLOTEPRETAP,
         DELETED.QTBRUTINSETP,
         DELETED.VRPRENINSETP,
         DELETED.IDTIPOPROPOR,
         DELETED.IDTIPOARREDO,
         DELETED.IDSUBOPINSU,
         INSERTED.CDFILIAL,
         INSERTED.CDPRODUTO,
         INSERTED.CDPROCFABRIC,
         INSERTED.CDETAPAPROD,
         INSERTED.CDPRODINSUMO,
         INSERTED.CDTIPOINSU,
         INSERTED.IDUTAPRREQET,
         INSERTED.QTINSUMETAPA,
         INSERTED.QTRENDINSU,
         INSERTED.IDSEMIACETAP,
         INSERTED.IDLOTEPRETAP,
         INSERTED.QTBRUTINSETP,
         INSERTED.VRPRENINSETP,
         INSERTED.IDTIPOPROPOR,
         INSERTED.IDTIPOARREDO,
         INSERTED.IDSUBOPINSU

      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDPRODUTO  = DELETED.CDPRODUTO

      UNION ALL

      SELECT
        'I' IDCOMANDO,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
	CDFILIAL,
	CDPRODUTO,
	CDPROCFABRIC,
	CDETAPAPROD,
	CDPRODINSUMO,
	CDTIPOINSU,
	IDUTAPRREQET,
	QTINSUMETAPA,
	QTRENDINSU,
	IDSEMIACETAP,
	IDLOTEPRETAP,
	QTBRUTINSETP,
	VRPRENINSETP,
	IDTIPOPROPOR,
	IDTIPOARREDO,
	IDSUBOPINSU

     FROM
        INSERTED
     WHERE
        0 = (SELECT COUNT(*) FROM DELETED)

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_TRIGGER,

				 @V_CDFILIAL_OLD,
				 @V_CDPRODUTO_OLD,
				 @V_CDPROCFABRIC_OLD,
				 @V_CDETAPAPROD_OLD,
				 @V_CDPRODINSUMO_OLD,
				 @V_CDTIPOINSU_OLD,
				 @V_IDUTAPRREQET_OLD,
				 @V_QTINSUMETAPA_OLD,
				 @V_QTRENDINSU_OLD,
				 @V_IDSEMIACETAP_OLD,
				 @V_IDLOTEPRETAP_OLD,
				 @V_QTBRUTINSETP_OLD,
                                 @V_VRPRENINSETP_OLD,
				 @V_IDTIPOPROPOR_OLD,
				 @V_IDTIPOARREDO_OLD,
				 @V_IDSUBOPINSU_OLD,

				 @V_CDFILIAL_NEW,
			         @V_CDPRODUTO_NEW,
				 @V_CDPROCFABRIC_NEW,
				 @V_CDETAPAPROD_NEW,
				 @V_CDPRODINSUMO_NEW,
				 @V_CDTIPOINSU_NEW,
				 @V_IDUTAPRREQET_NEW,
				 @V_QTINSUMETAPA_NEW,
                                 @V_QTRENDINSU_NEW,
                                 @V_IDSEMIACETAP_NEW,
                                 @V_IDLOTEPRETAP_NEW,
                                 @V_QTBRUTINSETP_NEW,
                                 @V_VRPRENINSETP_NEW,
                                 @V_IDTIPOPROPOR_NEW,
                                 @V_IDTIPOARREDO_NEW,
                                 @V_IDSUBOPINSU_NEW;


   WHILE (@@FETCH_STATUS = 0) BEGIN

    IF @V_ID_TRIGGER = 'I' BEGIN

           IF @V_CDFILIAL_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'Filial= ' + ISNULL(@V_CDFILIAL_NEW,'') + ' ';
           END;


           IF @V_CDPRODUTO_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdProd= ' + ISNULL(@V_CDPRODUTO_NEW,'') + ' ';
           END;


           IF @V_CDPROCFABRIC_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdProcFabric= ' + ISNULL(@V_CDPROCFABRIC_NEW,'') + ' ';
           END;


           IF @V_CDETAPAPROD_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdEtapaProduo= ' + ISNULL(@V_CDETAPAPROD_NEW,'') + ' ';
           END;


           IF @V_CDPRODINSUMO_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdProdInsumo= ' + ISNULL(@V_CDPRODINSUMO_NEW,'') + ' ';
           END;


           IF @V_CDTIPOINSU_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdTipoInsumo= ' + @V_CDTIPOINSU_NEW + ' ';
           END;


           IF @V_IDUTAPRREQET_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'IdUtiAprProdLoteCalcReqo= ' + ISNULL(@V_IDUTAPRREQET_NEW,'') + ' ';
           END;


           IF @V_QTINSUMETAPA_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'QtInsumEtapa= ' + RTRIM(CONVERT(CHAR, @V_QTINSUMETAPA_NEW)) + ' ';
           END;


           IF @V_QTRENDINSU_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'QtRendInsu= ' + RTRIM(CONVERT(CHAR, @V_QTRENDINSU_NEW)) + ' ';
           END;


           IF @V_IDSEMIACETAP_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'IdSemiAcEtap= ' + @V_IDSEMIACETAP_NEW + ' ';
           END;


           IF @V_IDLOTEPRETAP_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'IdLotePrEtap= ' + @V_IDLOTEPRETAP_NEW + ' ';
           END;


           IF @V_QTBRUTINSETP_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'QtBrutInsEtP= ' + RTRIM(CONVERT(CHAR, @V_QTBRUTINSETP_NEW)) + ' ';
           END;


           IF @V_VRPRENINSETP_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'VrPRenInsEtp= ' + RTRIM(CONVERT(CHAR, @V_VRPRENINSETP_NEW)) + ' ';
           END;


           IF @V_IDTIPOPROPOR_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'IdTipoPropor= ' + @V_IDTIPOPROPOR_NEW + ' ';
           END;


           IF @V_IDTIPOARREDO_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'IdTipoArredo= ' + @V_IDTIPOARREDO_NEW + ' ';
           END;


           IF @V_IDSUBOPINSU_NEW IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'IdSubOPInsu= ' + @V_IDSUBOPINSU_NEW + ' ';
           END;

           SET @V_ITPESQ = @V_CDFILIAL_NEW   + @V_CDPRODUTO_NEW   + @V_CDPROCFABRIC_NEW + @V_CDETAPAPROD_NEW +
                           @V_CDPRODINSUMO_NEW;

         SET @V_IDTIPOOPER = '1';
     END
     ELSE BEGIN
        IF @V_ID_TRIGGER = 'U' BEGIN

           IF (@V_CDFILIAL_OLD <> @V_CDFILIAL_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'Filial= ' + ISNULL(@V_CDFILIAL_NEW,'') + ' ';
           END;


           IF (@V_CDPRODUTO_OLD <> @V_CDPRODUTO_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'CdProd= ' + ISNULL(@V_CDPRODUTO_NEW,'') + ' ';
           END;


           IF (@V_CDPROCFABRIC_OLD <> @V_CDPROCFABRIC_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'CdProcFabric= ' + ISNULL(@V_CDPROCFABRIC_NEW,'') + ' ';
           END;


           IF (@V_CDETAPAPROD_OLD <> @V_CDETAPAPROD_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'CdEtapaProduo= ' + ISNULL(@V_CDETAPAPROD_NEW,'') + ' ';
           END;


           IF (@V_CDPRODINSUMO_OLD <> @V_CDPRODINSUMO_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'CdProdInsumo= ' + ISNULL(@V_CDPRODINSUMO_NEW,'') + ' ';
           END;


           IF (ISNULL(@V_CDTIPOINSU_OLD,'-1') <> ISNULL(@V_CDTIPOINSU_NEW,'-1')) BEGIN
              SET @V_DESC = @V_DESC + 'CdTipoInsumo= ' + @V_CDTIPOINSU_NEW + ' ';
           END;


           IF (@V_IDUTAPRREQET_OLD <> @V_IDUTAPRREQET_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'IdUtiAprProdLoteCalcReqo= ' + ISNULL(@V_IDUTAPRREQET_NEW,'') + ' ';
           END;


           IF (ISNULL(@V_QTINSUMETAPA_OLD,'-1') <> ISNULL(@V_QTINSUMETAPA_NEW,'-1')) BEGIN
              SET @V_DESC = @V_DESC + 'QtInsumEtapa= ' + RTRIM(CONVERT(CHAR, @V_QTINSUMETAPA_NEW)) + ' ';
           END;


           IF (ISNULL(@V_QTRENDINSU_OLD,'-1') <> ISNULL(@V_QTRENDINSU_NEW,'-1')) BEGIN
              SET @V_DESC = @V_DESC + 'QtRendInsu= ' + RTRIM(CONVERT(CHAR, @V_QTRENDINSU_NEW)) + ' ';
           END;


           IF (@V_IDSEMIACETAP_OLD <> @V_IDSEMIACETAP_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'IdSemiAcEtap= ' + @V_IDSEMIACETAP_NEW + ' ';
           END;


           IF (@V_IDLOTEPRETAP_OLD <> @V_IDLOTEPRETAP_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'IdLotePrEtap= ' + @V_IDLOTEPRETAP_NEW + ' ';
           END;


           IF (ISNULL(@V_QTBRUTINSETP_OLD,'-1') <> ISNULL(@V_QTBRUTINSETP_NEW,'-1')) BEGIN
              SET @V_DESC = @V_DESC + 'QtBrutInsEtP= ' + RTRIM(CONVERT(CHAR, @V_QTBRUTINSETP_NEW)) + ' ';
           END;


           IF (ISNULL(@V_VRPRENINSETP_OLD,'-1') <> ISNULL(@V_VRPRENINSETP_NEW,'-1')) BEGIN
              SET @V_DESC = @V_DESC + 'VrPRenInsEtp= ' + RTRIM(CONVERT(CHAR, @V_VRPRENINSETP_NEW)) + ' ';
           END;


           IF (@V_IDTIPOPROPOR_OLD <> @V_IDTIPOPROPOR_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'IdTipoPropor= ' + @V_IDTIPOPROPOR_NEW + ' ';
           END;


           IF (@V_IDTIPOARREDO_OLD <> @V_IDTIPOARREDO_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'IdTipoArredo= ' + @V_IDTIPOARREDO_NEW + ' ';
           END;


           IF (@V_IDSUBOPINSU_OLD <> @V_IDSUBOPINSU_NEW) BEGIN
              SET @V_DESC = @V_DESC + 'IdSubOPInsu= ' + @V_IDSUBOPINSU_NEW + ' ';
           END;


           SET @V_ITPESQ = @V_CDFILIAL_NEW   + @V_CDPRODUTO_NEW   + @V_CDPROCFABRIC_NEW + @V_CDETAPAPROD_NEW +
                           @V_CDPRODINSUMO_NEW;

           SET @V_IDTIPOOPER = '2';

        END;

        IF @V_ID_TRIGGER = 'D'  BEGIN

           IF @V_CDFILIAL_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'Filial= ' + ISNULL(@V_CDFILIAL_OLD,'') + ' ';
           END;


           IF @V_CDPRODUTO_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdProd= ' + ISNULL(@V_CDPRODUTO_OLD,'') + ' ';
           END;


           IF @V_CDPROCFABRIC_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdProcFabric= ' + ISNULL(@V_CDPROCFABRIC_OLD,'') + ' ';
           END;


           IF @V_CDETAPAPROD_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdEtapaProduo= ' + ISNULL(@V_CDETAPAPROD_OLD,'') + ' ';
           END;


           IF @V_CDPRODINSUMO_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdProdInsumo= ' + ISNULL(@V_CDPRODINSUMO_OLD,'') + ' ';
           END;


           IF @V_CDTIPOINSU_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'CdTipoInsumo= ' + @V_CDTIPOINSU_OLD + ' ';
           END;


           IF @V_IDUTAPRREQET_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'IdUtiAprProdLoteCalcReqo= ' + ISNULL(@V_IDUTAPRREQET_OLD,'') + ' ';
           END;


           IF @V_QTINSUMETAPA_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'QtInsumEtapa= ' + RTRIM(CONVERT(CHAR, @V_QTINSUMETAPA_OLD)) + ' ';
           END;


           IF @V_QTRENDINSU_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'QtRendInsu= ' + RTRIM(CONVERT(CHAR, @V_QTRENDINSU_OLD)) + ' ';
           END;


           IF @V_IDSEMIACETAP_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'IdSemiAcEtap= ' + @V_IDSEMIACETAP_OLD + ' ';
           END;


           IF @V_IDLOTEPRETAP_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'IdLotePrEtap= ' + @V_IDLOTEPRETAP_OLD + ' ';
           END;


           IF @V_QTBRUTINSETP_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'QtBrutInsEtP= ' + RTRIM(CONVERT(CHAR, @V_QTBRUTINSETP_OLD)) + ' ';
           END;


           IF @V_VRPRENINSETP_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'VrPRenInsEtp= ' + RTRIM(CONVERT(CHAR, @V_VRPRENINSETP_OLD)) + ' ';
           END;


           IF @V_IDTIPOPROPOR_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'IdTipoPropor= ' + @V_IDTIPOPROPOR_OLD + ' ';
           END;


           IF @V_IDTIPOARREDO_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'IdTipoArredo= ' + @V_IDTIPOARREDO_OLD + ' ';
           END;


           IF @V_IDSUBOPINSU_OLD IS NOT NULL BEGIN
              SET @V_DESC = @V_DESC + 'IdSubOPInsu= ' + @V_IDSUBOPINSU_OLD + ' ';
           END;

                  
           SET @V_ITPESQ = @V_CDFILIAL_OLD   + @V_CDPRODUTO_OLD   + @V_CDPROCFABRIC_OLD + @V_CDETAPAPROD_OLD + 
                           @V_CDPRODINSUMO_OLD;

           SET @V_IDTIPOOPER = '3';
        END;
     END;

     IF NOT (@V_DESC IS NULL) BEGIN



           INSERT INTO LOGOPERA ( NMTABELA, DTOPERACAO, NMRESPOPER,
                                  IDTIPOOPER,   DSOPERACAO, CDPESQITEM,
                                  DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                                  DSMETUSUOPER, CDORESPOPER)
                       VALUES   ('INSUMETAPA', GETDATE() ,    ISNULL(@V_NMOPERADOR,' '),
                                  @V_IDTIPOOPER,   @V_DESC, @V_ITPESQ,
                                  @V_DSSERVERRDM, @V_DSREMOTEADDR,  @V_DSREMOTEHOST,
                                  @V_DSSERVMETHOD,   @V_DSREMOTEOPER); 
     END;

   FETCH NEXT FROM C_CURSOR INTO @V_ID_TRIGGER,

				 @V_CDFILIAL_OLD,
				 @V_CDPRODUTO_OLD,
				 @V_CDPROCFABRIC_OLD,
				 @V_CDETAPAPROD_OLD,
				 @V_CDPRODINSUMO_OLD,
				 @V_CDTIPOINSU_OLD,
				 @V_IDUTAPRREQET_OLD,
				 @V_QTINSUMETAPA_OLD,
				 @V_QTRENDINSU_OLD,
				 @V_IDSEMIACETAP_OLD,
				 @V_IDLOTEPRETAP_OLD,
				 @V_QTBRUTINSETP_OLD,
                                 @V_VRPRENINSETP_OLD,
				 @V_IDTIPOPROPOR_OLD,
				 @V_IDTIPOARREDO_OLD,
				 @V_IDSUBOPINSU_OLD,

				 @V_CDFILIAL_NEW,
			         @V_CDPRODUTO_NEW,
				 @V_CDPROCFABRIC_NEW,
				 @V_CDETAPAPROD_NEW,
				 @V_CDPRODINSUMO_NEW,
				 @V_CDTIPOINSU_NEW,
				 @V_IDUTAPRREQET_NEW,
				 @V_QTINSUMETAPA_NEW,
                                 @V_QTRENDINSU_NEW,
                                 @V_IDSEMIACETAP_NEW,
                                 @V_IDLOTEPRETAP_NEW,
                                 @V_QTBRUTINSETP_NEW,
                                 @V_VRPRENINSETP_NEW,
                                 @V_IDTIPOPROPOR_NEW,
                                 @V_IDTIPOARREDO_NEW,
                                 @V_IDSUBOPINSU_NEW;

   END;

   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;

END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'LOG_CDP_INSUMETAPA','5.07.000';
GO
